package com.bjlt.spider.Service.impl;

import com.bjlt.spider.Service.ScExchangeRateService;
import com.bjlt.spider.dao.ScExchangeRateDao;
import com.bjlt.spider.entity.ScExchangeRate;
import com.bjlt.spider.util.RespEntity;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * sc_exchange_rate
 */
@Service
public  class ScExchangeRateServiceImpl implements ScExchangeRateService {
    @Autowired
	private ScExchangeRateDao scExchangeRateDao;
	
	@Override
	public List<ScExchangeRate> listPageScExchangeRate(ScExchangeRate scExchangeRate){
		return scExchangeRateDao.listPageScExchangeRate(scExchangeRate);
	}

	@Override
	public List<ScExchangeRate> listScExchangeRate(ScExchangeRate scExchangeRate){
	    return scExchangeRateDao.listScExchangeRate(scExchangeRate);
	}  

	
	@Override
	public RespEntity  deleteScExchangeRate(ScExchangeRate scExchangeRate){
		RespEntity respEntity = new RespEntity();
		try {
			scExchangeRateDao.deleteScExchangeRate(scExchangeRate);
			respEntity.setStatus(200);
			respEntity.setMessage("true");
		} catch (Exception e) {
			e.printStackTrace();
			respEntity.setStatus(100);
			respEntity.setMessage("false");
		}
		return respEntity;
	}
	

	
	@Override
	public RespEntity insertSelective(ScExchangeRate scExchangeRate){
		RespEntity respEntity = new RespEntity();
		try {
			scExchangeRate.setUpdateTime(DateUtil.getFormatDate(new Date(), DatePattren.TIME_FORMAT));
			if (scExchangeRate.getAdjustNum()!=null && !"null".equals(scExchangeRate.getAdjustNum())){
				scExchangeRate.setFinalRate(Double.valueOf(scExchangeRate.getAdjustNum())+Double.valueOf(scExchangeRate.getCurrencyRate()));
			}
			scExchangeRateDao.insertSelective(scExchangeRate);
			respEntity.setStatus(200);
			respEntity.setMessage("true");
		} catch (Exception e) {
			e.printStackTrace();
			respEntity.setStatus(100);
			respEntity.setMessage("false");
		}
		return respEntity;
	}
	
	@Override
	public RespEntity updateByPrimaryKeySelective(ScExchangeRate scExchangeRate){
		RespEntity respEntity = new RespEntity();
		try {
			scExchangeRate.setUpdateTime(DateUtil.getFormatDate(new Date(), DatePattren.TIME_FORMAT));
			if (scExchangeRate.getAdjustNum()!=null && !"null".equals(scExchangeRate.getAdjustNum())){
				scExchangeRate.setFinalRate(Double.valueOf(scExchangeRate.getAdjustNum())+Double.valueOf(scExchangeRate.getCurrencyRate()));
			}
			scExchangeRateDao.updateByPrimaryKeySelective(scExchangeRate);
			respEntity.setStatus(200);
			respEntity.setMessage("true");
		} catch (Exception e) {
			e.printStackTrace();
			respEntity.setStatus(100);
			respEntity.setMessage("false");
		}
		return respEntity;
	}
	
}