package com.bjlt.spider.controller;

import com.alibaba.fastjson.JSONObject;
import com.bjlt.spider.Service.AirSourceLineService;
import com.bjlt.spider.Service.ScCitycurrencyService;
import com.bjlt.spider.Service.ScExchangeRateService;
import com.bjlt.spider.Service.ScPolicyService;
import com.bjlt.spider.config.ConsumersThreadPool;
import com.bjlt.spider.entity.AirSourceLineVo;
import com.bjlt.spider.entity.ScCitycurrency;
import com.bjlt.spider.entity.ScPolicy;
import com.bjlt.spider.entity.SearchResponseEntity;
import com.bjlt.spider.util.DateUtils;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import com.luyn.date.DatePattren;
import com.luyn.date.DateUtil;
import com.luyn.http.okhttp.OkHttpDownLoader;
import com.luyn.http.okhttp.response.HttpResponse;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;


import java.io.IOException;
import java.util.*;
import java.util.concurrent.ExecutorService;

@RestController
@Slf4j
@RequestMapping(value = "/scPolicy")
public class ScPolicyController {

	@Autowired
	private ScPolicyService scPolicyService;

	@Autowired
	private AirSourceLineService airSourceLineService;

	@Autowired
	private ScCitycurrencyService scCitycurrencyService ;

	@Autowired
	private ConsumersThreadPool consumersThreadPool;

	@Autowired
	private ScExchangeRateService scExchangeRateService;

	@Value("${AKWEBURL}")
	private String AKWEBURL;

	@Value("${BIGPOINT}")
	private String BIGPOINT;


	/**
	 * 显示列表
	 * @param scPolicy
	 * @return
	 */
	@RequestMapping("list")
	public  Map<String, Object> list(ScPolicy scPolicy) {
		Map<String,Object> ret = Maps.newHashMap();
		List<ScPolicy> scPolicyList = scPolicyService.listPageScPolicy(scPolicy);
		if (scPolicyList!=null && scPolicyList.size()!=0){
			ret.put("total",scPolicyList.get(0).getTotal());
		}
		ret.put("rows",scPolicyList);
		return ret;
	}

	/**
	 * @author admin
	 * @date 2018-03-28
	 * AIRLINE->POLICY
	 */
	@RequestMapping(value = "generatePolicy",method = RequestMethod.POST)
	public  Map<String, Object> getAirLine() {

		ExecutorService executorService =
				consumersThreadPool.getExecutorService();

		long i = System.currentTimeMillis();
		List<AirSourceLineVo> airSourceLineVos = airSourceLineService.listAirSourceLine(AirSourceLineVo.builder().airSourceID("1").build());
		log.info("本次查询所有的航线耗时："+(System.currentTimeMillis()-i)/1000+"s,航线数量为："+airSourceLineVos.size());
		//获取当前日期3天后 30天的日期
		Date date = new Date();

		List<String> dateLists = Lists.newArrayList();

		for (int j = 3; j <63 ; j++) {
			Date dateBefore = DateUtils.getDateBefore(date, j);
			dateLists.add(DateUtil.getFormatDate(dateBefore, DatePattren.DATE_FORMAT));
		}

		airSourceLineVos.forEach(t->{
			List<ScCitycurrency> scCitycurrencies = scCitycurrencyService.listScCitycurrency(ScCitycurrency.builder().stationCode(t.getFromCity()).build());
			if (scCitycurrencies!=null && scCitycurrencies.size()!=0){
				String currencyCode =scCitycurrencies.get(0).getCurrencyCode();

				ScPolicyRunable scPolicyRunable = new ScPolicyRunable(scPolicyService,scExchangeRateService,
						t,
						dateLists,
						currencyCode,
						BIGPOINT,
						AKWEBURL
						);
				executorService.execute(scPolicyRunable);

			}

		});
		return null;
	}


}
