package com.bjlt.spider.dao.impl;

import com.bjlt.spider.dao.ScCitycurrencyDao;
import com.bjlt.spider.entity.ScCitycurrency;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
* sc_citycurrency
*/
@Repository
public class ScCitycurrencyDaoImpl implements ScCitycurrencyDao {
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Override
	public List<ScCitycurrency> listPageScCitycurrency(ScCitycurrency scCitycurrency) {
		StringBuffer s=new StringBuffer();
		String select = "select id, countryCode, currency_code, stationCode, currency_name, edit_user, update_time, add_time from sc_citycurrency ";
		s.append(select );
        Map<String,Object> m=map(scCitycurrency);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		scCitycurrency.setTotal(count(where,m.values().toArray()));
		s.append(where);


		String limit = " limit " + (scCitycurrency.getPageNum()-1)*scCitycurrency.getSize() + "," + scCitycurrency.getSize();

		s.append(limit);
		RowMapper<ScCitycurrency> rowMapper = new BeanPropertyRowMapper<ScCitycurrency>(ScCitycurrency.class);
		List<ScCitycurrency> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());
		Integer count = count(where,m.values().toArray());
		if (list.size()!=0){
			list.get(0).setTotal(count);
		}
		return list;
	}



    @Override
    public void insertSelective(ScCitycurrency scCitycurrency) {
		StringBuffer s = new StringBuffer();
		s.append("insert into sc_citycurrency(");
        Map<String, Object> m = map(scCitycurrency);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
		List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());

	s.append(String.join(",", wenhao));
		s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
	}

    @Override
    public void updateByPrimaryKeySelective(ScCitycurrency scCitycurrency) {
		StringBuffer s = new StringBuffer();
		s.append("update sc_citycurrency set ");
        Map<String, Object> m = map(scCitycurrency);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + scCitycurrency.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

	}



    @Override
    public List<ScCitycurrency> listScCitycurrency(ScCitycurrency scCitycurrency) {
        StringBuffer s=new StringBuffer();
        String select = "select id, countryCode, currency_code, stationCode, currency_name, edit_user, update_time, add_time from sc_citycurrency ";
        s.append(select );
        Map<String,Object> m=map(scCitycurrency);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<ScCitycurrency> rowMapper = new BeanPropertyRowMapper<ScCitycurrency>(ScCitycurrency.class);
        List<ScCitycurrency> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
	}
	public void  deleteScCitycurrency(ScCitycurrency scCitycurrency){
		StringBuffer s=new StringBuffer();
		String select = "delete  from sc_citycurrency ";
        Map<String,Object> m=map(scCitycurrency);
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
		jdbcTemplate.update(s.toString(),m.values().toArray());

	}
	private static Map<String,Object> map(ScCitycurrency scCitycurrency) {
		Map<String,Object> map=new HashMap();
    	if (scCitycurrency.getId() != null) {
            map.put("id",scCitycurrency.getId());
    	}
    	if (scCitycurrency.getCountryCode() != null && !scCitycurrency.getCountryCode().equals("")) {
            map.put("countryCode",scCitycurrency.getCountryCode());
    	}
    	if (scCitycurrency.getCurrencyCode() != null && !scCitycurrency.getCurrencyCode().equals("")) {
            map.put("currency_code",scCitycurrency.getCurrencyCode());
    	}
    	if (scCitycurrency.getStationCode() != null && !scCitycurrency.getStationCode().equals("")) {
            map.put("stationCode",scCitycurrency.getStationCode());
    	}
    	if (scCitycurrency.getCurrencyName() != null && !scCitycurrency.getCurrencyName().equals("")) {
            map.put("currency_name",scCitycurrency.getCurrencyName());
    	}
    	if (scCitycurrency.getEditUser() != null && !scCitycurrency.getEditUser().equals("")) {
            map.put("edit_user",scCitycurrency.getEditUser());
    	}
    	if (scCitycurrency.getUpdateTime() != null && !scCitycurrency.getUpdateTime().equals("")) {
            map.put("update_time",scCitycurrency.getUpdateTime());
    	}
    	if (scCitycurrency.getAddTime() != null && !scCitycurrency.getAddTime().equals("")) {
            map.put("add_time",scCitycurrency.getAddTime());
    	}

		return map;

	}
	private Integer count(String where,Object[] objects) {
		String sql = "select count(*) from sc_citycurrency " + where;
		return jdbcTemplate.queryForObject(sql, Integer.class,objects);
	}




}
