package com.bjlt.spider.dao.impl;

import com.bjlt.spider.dao.ScExchangeRateDao;
import com.bjlt.spider.entity.ScExchangeRate;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Repository;

import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
* sc_exchange_rate
*/
@Repository
public class ScExchangeRateDaoImpl implements ScExchangeRateDao {
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Override
	public List<ScExchangeRate> listPageScExchangeRate(ScExchangeRate scExchangeRate) {
		StringBuffer s=new StringBuffer();
		String select = "select id, group_id, fore_currency, exchange_currency, currency_rate,adjust_num,final_rate, edit_user, update_time, add_time from sc_exchange_rate ";
		s.append(select );
        Map<String,Object> m=map(scExchangeRate);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		scExchangeRate.setTotal(count(where,m.values().toArray()));
		s.append(where);
		if (StringUtils.isNotBlank(scExchangeRate.getStartDate())&&!scExchangeRate.getStartDate().equals(scExchangeRate.getEndDate()) ){
			String sql=" and update_time >= date_add('"+scExchangeRate.getStartDate().trim()+"',interval  '0' HOUR_SECOND)";
			s.append(sql);
		}
		if (StringUtils.isNotBlank(scExchangeRate.getEndDate())&&!scExchangeRate.getStartDate().equals(scExchangeRate.getEndDate()) ){
			String sql=" and update_time <= date_add('"+scExchangeRate.getEndDate().trim()+"',interval  '23:59:59' HOUR_SECOND)";
			s.append(sql);
		}

		if (StringUtils.isNotBlank(scExchangeRate.getStartDate())
				&&StringUtils.isNotBlank(scExchangeRate.getEndDate())
				&&scExchangeRate.getStartDate().equals(scExchangeRate.getEndDate())){
			String sql=" and update_time >= date_add('"+scExchangeRate.getStartDate().trim()+"',interval  '0' HOUR_SECOND)"+
					" and update_time <= date_add('"+scExchangeRate.getEndDate().trim()+"',interval  '23:59:59' HOUR_SECOND)";
			s.append(sql);
		}

		String limit = " limit " + (scExchangeRate.getPageNum()-1)*scExchangeRate.getSize() + "," + scExchangeRate.getSize();

		s.append(limit);
		RowMapper<ScExchangeRate> rowMapper = new BeanPropertyRowMapper<ScExchangeRate>(ScExchangeRate.class);
		List<ScExchangeRate> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());
		Integer count =count(where ,m.values().toArray());

		if (list.size()!=0){
			list.get(0).setTotal(count);
		}
		return list;
	}



    @Override
    public void insertSelective(ScExchangeRate scExchangeRate) {
		StringBuffer s = new StringBuffer();
		s.append("insert into sc_exchange_rate(");
        Map<String, Object> m = map(scExchangeRate);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
		List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());

	s.append(String.join(",", wenhao));
		s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
	}

    @Override
    public void updateByPrimaryKeySelective(ScExchangeRate scExchangeRate) {
		StringBuffer s = new StringBuffer();
		s.append("update sc_exchange_rate set ");
        Map<String, Object> m = map(scExchangeRate);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + scExchangeRate.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

	}



    @Override
    public List<ScExchangeRate> listScExchangeRate(ScExchangeRate scExchangeRate) {
        StringBuffer s=new StringBuffer();
        String select = "select id, group_id, fore_currency, exchange_currency, currency_rate, adjust_num,final_rate,edit_user, update_time, add_time from sc_exchange_rate ";
        s.append(select );
        Map<String,Object> m=map(scExchangeRate);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<ScExchangeRate> rowMapper = new BeanPropertyRowMapper<ScExchangeRate>(ScExchangeRate.class);
        List<ScExchangeRate> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
	}
	public void  deleteScExchangeRate(ScExchangeRate scExchangeRate){
		StringBuffer s=new StringBuffer();
		String select = "delete  from sc_exchange_rate ";
        Map<String,Object> m=map(scExchangeRate);
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
		jdbcTemplate.update(s.toString(),m.values().toArray());

	}
	private static Map<String,Object> map(ScExchangeRate scExchangeRate) {
		Map<String,Object> map=new HashMap();
    	if (scExchangeRate.getId() != null) {
            map.put("id",scExchangeRate.getId());
    	}
    	if (scExchangeRate.getGroupId() != null && !scExchangeRate.getGroupId().equals("")) {
            map.put("group_id",scExchangeRate.getGroupId());
    	}
    	if (scExchangeRate.getForeCurrency() != null && !scExchangeRate.getForeCurrency().equals("")) {
            map.put("fore_currency",scExchangeRate.getForeCurrency());
    	}
    	if (scExchangeRate.getExchangeCurrency() != null && !scExchangeRate.getExchangeCurrency().equals("")) {
            map.put("exchange_currency",scExchangeRate.getExchangeCurrency());
    	}
    	if (scExchangeRate.getCurrencyRate() != null) {
            map.put("currency_rate",scExchangeRate.getCurrencyRate());
    	}
    	if (scExchangeRate.getEditUser() != null && !scExchangeRate.getEditUser().equals("")) {
            map.put("edit_user",scExchangeRate.getEditUser());
    	}
    	if (scExchangeRate.getUpdateTime() != null && !scExchangeRate.getUpdateTime().equals("")) {
            map.put("update_time",scExchangeRate.getUpdateTime());
    	}
    	if (scExchangeRate.getAddTime() != null && !scExchangeRate.getAddTime().equals("")) {
            map.put("add_time",scExchangeRate.getAddTime());
    	}
		if (scExchangeRate.getAdjustNum()!=null && !"".equals(scExchangeRate.getAdjustNum())){
			map.put("adjust_num",scExchangeRate.getAdjustNum());
		}
		if (scExchangeRate.getFinalRate()!=null && !"".equals(scExchangeRate.getFinalRate())){
			map.put("final_rate",scExchangeRate.getFinalRate());
		}
		return map;

	}
	private Integer count(String where,Object[] objects) {
		String sql = "select count(*) from sc_exchange_rate " + where;
		return jdbcTemplate.queryForObject(sql, Integer.class,objects);
	}




}
