package com.bjlt.spider.dao.impl;

import com.bjlt.spider.dao.ScPolicyDao;
import com.bjlt.spider.entity.ScPolicy;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.*;

import org.springframework.stereotype.Repository;

import java.util.*;
import java.util.stream.*;
/**
* sc_policy
*/
@Repository
public class ScPolicyDaoImpl implements ScPolicyDao {
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Override
	public List<ScPolicy> listPageScPolicy(ScPolicy scPolicy) {
		StringBuffer s=new StringBuffer();
		String select = "select id, air_source_group_id, cid, from_city, to_city, from_date_start, from_date_end, exclude_from_date_start, exclude_from_date_end, flight_number_limit_type, flight_number_limit, original_price, adjust_type, final_price, adjust_radio, add_or_subtract_money, score, low_price, up_price, edit_user, bidder, file_no, update_time, add_time, status, cabin_scope, policy_source from sc_policy ";
		s.append(select );
        Map<String,Object> m=map(scPolicy);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
		scPolicy.setTotal(count(where,m.values().toArray()));
		s.append(where);


		String limit = " limit " + (scPolicy.getStart()-1)*scPolicy.getSize() + "," + scPolicy.getSize();

		s.append(limit);
		RowMapper<ScPolicy> rowMapper = new BeanPropertyRowMapper<ScPolicy>(ScPolicy.class);
		List<ScPolicy> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());
		if (list!=null && list.size()!=0){
			list.get(0).setTotal(count(where,m.values().toArray()));
		}
		return list;
	}



    @Override
    public void insertSelective(ScPolicy scPolicy) {
		StringBuffer s = new StringBuffer();
		s.append("insert into sc_policy(");
        Map<String, Object> m = map(scPolicy);
        s.append(String.join(",", m.keySet()));
        s.append(") values (");
		List<String> wenhao = m.keySet().stream().map(t -> "?").collect(Collectors.toList());

	s.append(String.join(",", wenhao));
		s.append(")");
        System.out.println(s.toString());
        jdbcTemplate.update(s.toString(), m.values().toArray());
	}

    @Override
    public void updateByPrimaryKeySelective(ScPolicy scPolicy) {
		StringBuffer s = new StringBuffer();
		s.append("update sc_policy set ");
        Map<String, Object> m = map(scPolicy);
        String update = m.keySet().stream().map(t -> t + "=?").collect(Collectors.joining(","));
        s.append(update);
        System.out.println(update);
        s.append(" where 	id=" + scPolicy.getId());
        jdbcTemplate.update(s.toString(), m.values().toArray());

	}



    @Override
    public List<ScPolicy> listScPolicy(ScPolicy scPolicy) {
        StringBuffer s=new StringBuffer();
        String select = "select id, air_source_group_id, cid, from_city, to_city, from_date_start, from_date_end, exclude_from_date_start, exclude_from_date_end, flight_number_limit_type, flight_number_limit, original_price, adjust_type, final_price, adjust_radio, add_or_subtract_money, score, low_price, up_price, edit_user, bidder, file_no, update_time, add_time, status, cabin_scope, policy_source from sc_policy ";
        s.append(select );
        Map<String,Object> m=map(scPolicy);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
        RowMapper<ScPolicy> rowMapper = new BeanPropertyRowMapper<ScPolicy>(ScPolicy.class);
        List<ScPolicy> list = jdbcTemplate.query(s.toString(), rowMapper,m.values().toArray());

        return list;
	}
    @Override
	public void  deleteScPolicy(ScPolicy scPolicy){
		StringBuffer s=new StringBuffer();
		String select = "delete  from sc_policy ";
        Map<String,Object> m=map(scPolicy);
        s.append(select);
        String where = "where 1=1 " + m.keySet().stream().map(t -> " and " + t + "=?").collect(Collectors.joining(" "));
        s.append(where);
		jdbcTemplate.update(s.toString(),m.values().toArray());

	}
	private static Map<String,Object> map(ScPolicy scPolicy) {
		Map<String,Object> map=new HashMap();
    	if (scPolicy.getId() != null) {
            map.put("id",scPolicy.getId());
    	}
    	if (scPolicy.getAirSourceGroupId() != null) {
            map.put("air_source_group_id",scPolicy.getAirSourceGroupId());
    	}
    	if (scPolicy.getCid() != null && !scPolicy.getCid().equals("")) {
            map.put("cid",scPolicy.getCid());
    	}
    	if (scPolicy.getFromCity() != null && !scPolicy.getFromCity().equals("")) {
            map.put("from_city",scPolicy.getFromCity());
    	}
    	if (scPolicy.getToCity() != null && !scPolicy.getToCity().equals("")) {
            map.put("to_city",scPolicy.getToCity());
    	}
    	if (scPolicy.getFromDateStart() != null && !scPolicy.getFromDateStart().equals("")) {
            map.put("from_date_start",scPolicy.getFromDateStart());
    	}
    	if (scPolicy.getFromDateEnd() != null && !scPolicy.getFromDateEnd().equals("")) {
            map.put("from_date_end",scPolicy.getFromDateEnd());
    	}
    	if (scPolicy.getExcludeFromDateStart() != null && !scPolicy.getExcludeFromDateStart().equals("")) {
            map.put("exclude_from_date_start",scPolicy.getExcludeFromDateStart());
    	}
    	if (scPolicy.getExcludeFromDateEnd() != null && !scPolicy.getExcludeFromDateEnd().equals("")) {
            map.put("exclude_from_date_end",scPolicy.getExcludeFromDateEnd());
    	}
    	if (scPolicy.getFlightNumberLimitType() != null) {
            map.put("flight_number_limit_type",scPolicy.getFlightNumberLimitType());
    	}
    	if (scPolicy.getFlightNumberLimit() != null && !scPolicy.getFlightNumberLimit().equals("")) {
            map.put("flight_number_limit",scPolicy.getFlightNumberLimit());
    	}
    	if (scPolicy.getOriginalPrice() != null) {
            map.put("original_price",scPolicy.getOriginalPrice());
    	}
    	if (scPolicy.getAdjustType() != null && !scPolicy.getAdjustType().equals("")) {
            map.put("adjust_type",scPolicy.getAdjustType());
    	}
    	if (scPolicy.getFinalPrice() != null) {
            map.put("final_price",scPolicy.getFinalPrice());
    	}
    	if (scPolicy.getAdjustRadio() != null && !scPolicy.getAdjustRadio().equals("")) {
            map.put("adjust_radio",scPolicy.getAdjustRadio());
    	}
    	if (scPolicy.getAddOrSubtractMoney() != null && !scPolicy.getAddOrSubtractMoney().equals("")) {
            map.put("add_or_subtract_money",scPolicy.getAddOrSubtractMoney());
    	}
    	if (scPolicy.getScore() != null && !scPolicy.getScore().equals("")) {
            map.put("score",scPolicy.getScore());
    	}
    	if (scPolicy.getLowPrice() != null) {
            map.put("low_price",scPolicy.getLowPrice());
    	}
    	if (scPolicy.getUpPrice() != null) {
            map.put("up_price",scPolicy.getUpPrice());
    	}
    	if (scPolicy.getEditUser() != null && !scPolicy.getEditUser().equals("")) {
            map.put("edit_user",scPolicy.getEditUser());
    	}
    	if (scPolicy.getBidder() != null && !scPolicy.getBidder().equals("")) {
            map.put("bidder",scPolicy.getBidder());
    	}
    	if (scPolicy.getFileNo() != null && !scPolicy.getFileNo().equals("")) {
            map.put("file_no",scPolicy.getFileNo());
    	}
    	if (scPolicy.getUpdateTime() != null && !scPolicy.getUpdateTime().equals("")) {
            map.put("update_time",scPolicy.getUpdateTime());
    	}
    	if (scPolicy.getAddTime() != null && !scPolicy.getAddTime().equals("")) {
            map.put("add_time",scPolicy.getAddTime());
    	}
    	if (scPolicy.getStatus() != null) {
            map.put("status",scPolicy.getStatus());
    	}
    	if (scPolicy.getCabinScope() != null && !scPolicy.getCabinScope().equals("")) {
            map.put("cabin_scope",scPolicy.getCabinScope());
    	}
    	if (scPolicy.getPolicySource() != null && !scPolicy.getPolicySource().equals("")) {
            map.put("policy_source",scPolicy.getPolicySource());
    	}

		return map;

	}
	private Integer count(String where,Object[] objects) {
		String sql = "select count(*) from sc_policy " + where;
		return jdbcTemplate.queryForObject(sql, Integer.class,objects);
	}




}
